<template>
  <q-table
    v-model:pagination="pagination"
    class="col-12 sticky-header-column-table"
    :rows="rows"
    :columns="columns"
    row-key="name"
    :visible-columns="visibleColumns"
    :loading="loading"
    @request="onRequest"
  >
    <template #top>
      <div class="col-2 q-table__title">
        {{ title }}
      </div>

      <q-space />

      <div
        v-if="$q.screen.gt.xs"
        class="col"
      >
        <q-toggle
          v-model="visibleColumns"
          val="bodyMessage"
          label="Zpráva"
        />
        <q-toggle
          v-model="visibleColumns"
          val="bodyType"
          label="Typ"
        />
        <q-toggle
          v-model="visibleColumns"
          val="bodyCode"
          label="Kód"
        />
        <q-toggle
          v-model="visibleColumns"
          val="state"
          label="Status"
        />
        <q-toggle
          v-model="visibleColumns"
          val="service"
          label="Service"
        />
        <q-toggle
          v-model="visibleColumns"
          val="stack"
          label="Stack"
        />
      </div>
      <q-select
        v-else
        v-model="visibleColumns"
        multiple
        borderless
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 150px"
      />
    </template>
    <template
      #body-cell-message="props"
    >
      <q-td :props="props">
        <pre>{{ props.value }}</pre>
      </q-td>
    </template>
    <template #loading>
      <q-inner-loading
        showing
        color="primary"
      />
    </template>
  </q-table>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import { onMounted, PropType } from '@vue/runtime-core'
import { defineComponent } from 'vue'
import { LogErrorRow, LogErrorType } from 'web_trains_types'

import { dateToStr } from '@/helper/dateTime'
import { errorService } from '@/service'

function toJson (message: string): string {
  try {
    const json = JSON.parse(message)
    return JSON.stringify(json, null, 2)
  } catch (e) {
    return message
  }
}

const columns = [
  {
    name: 'timestamp',
    field: (row: LogErrorRow) => dateToStr(row.timestamp, 'Ppp'),
    label: 'Čas',
    required: true,
    align: 'left',
    sortable: true
  },
  {
    name: 'level',
    field: 'level',
    label: 'Stupeň',
    required: true,
    align: 'left',
    sortable: true
  },
  {
    name: 'message',
    field: (row: LogErrorRow) => toJson(row.message),
    label: 'Zpráva',
    required: true,
    align: 'left'
  },
  {
    name: 'bodyMessage',
    field: (row: LogErrorRow) => row.body === undefined ? '' : row.body.message,
    label: 'Zpráva',
    required: false,
    align: 'left'
  },
  {
    name: 'bodyType',
    field: (row: LogErrorRow) => row.body === undefined ? '' : row.body.type,
    label: 'Typ',
    required: false,
    align: 'left'
  },
  {
    name: 'bodyCode',
    field: (row: LogErrorRow) => row.body === undefined ? '' : row.body.code,
    label: 'Kód',
    required: false,
    align: 'left'
  },
  {
    name: 'state',
    field: (row: LogErrorRow) => row.status ?? '',
    label: 'Status',
    required: false,
    align: 'left'
  },
  {
    name: 'service',
    field: (row: LogErrorRow) => row.service ?? '',
    label: 'Service',
    required: false,
    align: 'left'
  },
  {
    name: 'stack',
    field: (row: LogErrorRow) => row.stack ?? '',
    label: 'Stack',
    required: false,
    align: 'left'
  }
]

export default defineComponent({
  name: 'ErrorTable',
  props: {
    type: {
      type: Object as PropType<LogErrorType>,
      required: true,
      default: LogErrorType.client
    },
    title: {
      type: String,
      required: true,
      default: ''
    }
  },
  setup (prop): any {
    const loading = ref(true)

    const rows = ref<LogErrorRow[]>()

    const pagination = ref({
      sortBy: 'timestamp',
      descending: false,
      page: 1,
      rowsPerPage: 3,
      rowsNumber: 10
    })

    const onRequest = (props: any) => {
      const { page, rowsPerPage, sortBy, descending } = props.pagination

      errorService.getCount(prop.type)
        .then((rowsNumber) => {
          pagination.value.rowsNumber = rowsNumber

          errorService.getAll({
            type: prop.type,
            offset: (page - 1) * rowsPerPage,
            count: rowsPerPage === 0 ? pagination.value.rowsNumber : rowsPerPage
          })
            .then((data) => {
              if (rows.value === undefined) {
                rows.value = data
              } else {
                rows.value.splice(0, rows.value.length, ...data)
              }

              pagination.value.page = page
              pagination.value.rowsPerPage = rowsPerPage
              pagination.value.sortBy = sortBy
              pagination.value.descending = descending
            })
        })
        .finally(() => { loading.value = false })
    }

    onMounted(() => {
      onRequest({
        pagination: pagination.value
      })
    })

    return {
      columns,
      rows,
      visibleColumns: ref([]),
      pagination,
      loading,
      onRequest
    }
  }
})

</script>
